<?
// originally DirCaster v0.3: Automatic iPodder RSS feed maker
// Written by Ryan King 			www.shadydentist.com
// hacked by Tim Baker tim@tjbaker.co.uk to do id3v2 tags and fixed parser problem with ampersands
// so please don't bother Ryan with questions about this as it's been modded; released as part of GPL but with absolutely no guarantees, I'm a hacker not a coder! Please feel free to amend.

// Drop this script in a directory and it will generate an RSS feed suitable for
// iPodder, etc based off the MP3 files in that directory. To 'cast a new
// file, simply upload it to the directory containing this script.

// Feed information is based on id3 tags, requires PHP4 or better.
//
// Note: Avoid spaces in your MP3 filenames to avoid ugly filenames coming out
// of iPodder

// Instructions
// 1. Place this file on a server with supports PHP4 or greater.
// 2. Place MP3 files to feed in the same directory, add new files at will
// 3. Point iPodder to the URL of this file.
// ex. http://www.mysite.com/podcast/dircaster.php
// 4. Set the following varibles to match your setup if you wish

// Maximum number of mp3s to offer in a feed
$maxFeed = 10;

//Title of feed/site	Used by iPodder for download subdirectory name
$titleTAG="Title";

//iPodder 1.0 seems to ignore everything below
//URL of site feed applies too
$linkTAG="http://www.yoursitedomain.net";
//Description
$descriptionTAG="Your description";
//Feed language en-us = english UK
$languageTAG="en-uk";
//Copyright for feed
$copyrightTAG="Copywhat?";
//Your email address
$webMasterTAG="you@yourdomain.net";
//Name of feed generator
$generatorTAG="dirCastv0.1";
// Time to live
$ttlTAG=60;

$redirectURL = "http://www.yoursitedomain.net";

///////////////
// You should not need to edit anything below this point.
/////////////
// Main Code
///////////
header('Content-type: text/xml', true);
$rootMP3URL = "http://" . $_SERVER[HTTP_HOST] . $_SERVER[REQUEST_URI];
$rootMP3URL =  substr($rootMP3URL, 0, strrpos ($rootMP3URL, "/")); // Trim off script name itself

print "<?xml version=\"1.0\"?>\n";
print "<rss version=\"2.0\">\n";
print"	<channel>\n";
print"		<title>$titleTAG</title>\n";
print"		<link>$linkTAG</link>\n";
print"		<description>$descriptionTAG</description>\n";
print"		<lastBuildDate>" . date("r") ."</lastBuildDate>\n";
print"		<language>$languageTAG</language>\n";
print"		<copyright>$copyrightTAG</copyright>\n";
print"		<generator>$generatorTAG</generator>\n";
print"		<webMaster>$webMasterTAG</webMaster>\n";
print"		<ttl>$ttlTAG</ttl>\n\n";

$dirArray = getDir(".");	// Get a list of the current directory
while (list($filename, $filedate) = each($dirArray)AND $maxFeed > 0) {
$id3 = new id3($filename);
$rawtitle = $id3->title();
$rawartist= $id3->artist();
$rawcomment = $id3->comment();
$title = stripJunk ($rawtitle);
$artist = stripJunk ($rawartist);
$comment = stripJunk ($rawcomment);
	print "<item>\n";
	echo ("<title>$title</title>\n");
	echo ("<link>$redirectURL/". str_replace(" ", "%20", $filename) ."</link>\n");
	echo ("<description>$artist:$comment</description>\n");
	echo ("<pubDate>".date("r",$filedate)."</pubDate>\n");
	echo ("<enclosure url=\"$redirectURL/". str_replace(" ", "%20", $filename) ."\" length=\"");
	echo filesize($filename);
	echo ("\" type=\"audio/mpeg\"/>\n");	// Training slash for XML
	print "</item>\n\n";
	$maxFeed--;
}

print "</channel>\n</rss>\n";


################################################################################
#
# ID3v2.php
# Lesen von ID3v1/1.1
#			ID3v2.2
#			ID3v2.3 und MPEG-Frame-Header-Informationen
#
# Copyright  2002-2003 Michael Zeising <software@michaels-website.de>

$id3_version = '0.1.4';

# ID3v2.2-FrameIDs
$v3_v2 = array('TPE1' => 'TP1',
			   'TIT2' => 'TT2',
			   'TALB' => 'TAL',
			   'TCON' => 'TCO',
			   'TYER' => 'TYE',
			   'TRCK' => 'TRK',
			   'COMM' => 'COM');

class id3 {
	var $_lastfile;
	var $_filename;
	var $_error;

	var $_id3v1;				# ID3v1/1.1-Tag (128 Bytes)
	var $_id3v1_included;		# Gibt an, ob ein ID3v1-Tag enthalten ist

	var $_id3v2;
	var $_id3v2_header;			# Kopf des ID3v2-Tags (10 Bytes)
	var $_id3v2_included;		# Gibt an, ob ein ID3v2-Tag enthalten ist
	var $_id3v2_major;			# ID3v2 Version
	var $_id3v2_minor;			# ID3v2 Release

	var $_frame_found;			# Gibt an, ob ein MPEG-Frame in der Datei
								# gefunden wurde
	var $_frame_offset;			# Offset des ersten MPEG-Frames
	var $_frame_header;			# Kopf des ersten MPEG-Frames (4 Bytes/32 Bits)

	############################################################################
	# Konstruktorfunktion
	# VOID id3(STRING filename)
	function id3($filename) {
		$this->_error = '';
		$this->_filename = $filename;
	}

	############################################################################
	# Version der Klasse zurckgeben
	# STRING version()
	function version() {
		return $GLOBALS[id3_version];
	}

	############################################################################
	# Knstler vom Dateinamen ableiten (Knstler - Titel.mp3)
	# STRING artist_from_filename()
	function artist_from_filename() {
		$filename = basename($this->_filename);
		# .mp3-Endung entfernen
		$filename = substr($filename, 0, strlen($filename) - 4);
		# Unterstriche durch Leerzeichen ersetzen
		$filename = str_replace('_', ' ',$filename);

		$artist = substr($filename, 0, strpos($filename, '-'));
		$artist = trim($artist);

		return $artist;
	}

	############################################################################
	# Titel vom Dateinamen ableiten (Knstler - Titel.mp3)
	# STRING title_from_filename()
	function title_from_filename() {
		$filename = basename($this->_filename);
		# .mp3-Endung entfernen
		$filename = substr($filename, 0, strlen($filename) - 4);
		# Unterstriche durch Leerzeichen ersetzen
		$filename = str_replace('_', ' ',$filename);

		$title = substr($filename, strpos($filename, '-') + 1, strlen($filename) - strpos($filename, '-'));
		$title = trim($title);

		return $title;
	}

	############################################################################
	# ID3v1-Tags, ID3v2-Tags und MPEG-Frame-Header lesen
	# BOOL _read_id3()
	function _read_id3() {

		if ($this->_lastfile != $this->_filename) {
			$this->_lastfile = $this->_filename;

			if (!file_exists($this->_filename)) {
				$this->_error = 'File not found'; return false;
			}

			if (!is_readable($this->_filename)) {
				$this->_error = 'File not readable'; return false;
			}

			$fp = fopen($this->_filename, "r");

			$this->_id3v2_header = fread($fp, 10);					# ID3v2

			if (substr($this->_id3v2_header, 0, 3) == 'ID3') {
				$this->_id3v2_included = true;

				$tag_size = big_endian_to_int(substr($this->_id3v2_header, 6, 4), true);

				$this->_id3v2 = fread($fp, ($tag_size - 10));
			}

			rewind($fp);

			while ($sync != chr(255) && $no_frame == false) {		# MPEG
				if (feof($fp)) $no_frame = true;
				else $sync = fread($fp, 1);
			}

			if ($no_frame == false) {
				fseek($fp, ftell($fp) - 1);
				$this->_frame_offset = ftell($fp) - 1;
				$this->_frame_header = fread($fp, 4);
				$this->_frame_found = true;
			} else $this->_frame_found = false;

			if (filesize($this->_filename) > 128) {					# ID3v1
				fseek($fp, filesize($this->_filename) - 128);
				$this->_id3v1 = fread($fp, 128);
			} else $this->_id3v1_included = false;

			fclose($fp);


			$this->_id3v1_included = (bool) (substr($this->_id3v1, 0, 3) == 'TAG');

			if ($this->_id3v2_included == true) {
				$this->_id3v2_major = ord($this->_id3v2_header[3]);
				$this->_id3v2_minor = ord($this->_id3v2_header[4]);

				if ($this->_id3v2_major > 4) {
					$this->_error = 'ID3v2.'.$this->_id3v2_major.' is not supported.'; return false;
				}
			}
		}

		return true;
	}

	############################################################################
	#									ID3								       #
	############################################################################

	############################################################################
	# Inhalt eines 'Text Information Frame' interpretieren
	# STRING _parse_text_frame(STRING frame_content)
	# frame_content		Inhalt des Frames
	function _parse_text_frame($frame_content) {
		#  Muster fr FrameID 'T...' (nicht TXXX)
		#
		#  +-------------------------+
		#  |   (Frame Header T...)   |
		#  +-------------------------+
		#  | Text-Codierung (1 Byte) |
		#  +-------------------------+
		#  |	 	 Inhalt			 |
		#  +-------------------------+
		#
		#  Text-Codierungen:
		#  $00	ISO-8859-1
		#  $01	16-Bit Unicode (UTF-16) mit BOM*
		#  $02	16-Bit Unicode (UTF-16) ohne BOM*
		#  $03	8-Bit Unicode (UTF-8)*
		#
		#  *) werden noch nicht untersttzt
		#
		#########################################

		if (ord(substr($frame_content, 0, 1)) == 0) {		# ISO-8859-1
			$content = substr($frame_content, 1, strlen($frame_content) - 1);
		}
		elseif (ord(substr($frame_content, 0, 1)) == 1) {	# UTF-16 mit BOM
			$this->_error = 'UTF-16 text encoding in frame '.$frame_id.' is not yet supported.';
			return '';
		}
		elseif (ord(substr($frame_content, 0, 1)) == 2) {	# UTF-16 ohne BOM
			$this->_error = 'UTF-16 text encoding in frame '.$frame_id.' is not yet supported.';
			return '';
		}
		elseif (ord(substr($frame_content, 0, 1)) == 3) {	# UTF-8
			$this->_error = 'UTF-8 text encoding in frame '.$frame_id.' is not yet supported.';
			return '';
		}
		else {
			$this->_error = 'Unknown text encoding id '.ord(substr($frame_content, 0, 1)).' in frame '.$frame_id.'.';
			return '';
		}

		return $content;
	}

	############################################################################
	# Prfen, ob sich irgendein Tag in der Datei befindet
	# BOOL tag_included()
	function tag_included() {
		$this->_read_id3();

		if ($this->_id3v1_included or $this->_id3v2_included) return true;
		else return false;
	}

	############################################################################
	# ID3 - Knstler
	# STRING artist()
	function artist() {
		$this->_read_id3();

		if ($this->_id3v2_included) {
			return $this->_parse_text_frame($this->_id3v2_frame('TPE1'));
		}
		elseif ($this->_id3v1_included) return chop(substr($this->_id3v1, 33, 30));
		else return '';
	}

	############################################################################
	# ID3 - Titel
	# STRING title()
	function title() {
		$this->_read_id3();

		if ($this->_id3v2_included) {
			return $this->_parse_text_frame($this->_id3v2_frame('TIT2'));
		}
		elseif ($this->_id3v1_included) return chop(substr($this->_id3v1, 3, 30));
		else return '';
	}

	############################################################################
	# ID3 - Album
	# STRING album()
	function album() {
		$this->_read_id3();

		if ($this->_id3v2_included) {
			return $this->_parse_text_frame($this->_id3v2_frame('TALB'));
		}
		elseif ($this->_id3v1_included) return chop(substr($this->_id3v1, 63, 30));
		else return '';
	}


	############################################################################
	# ID3 - Kommentar
	# STRING comment()
	function comment() {
		#  Muster fr FrameID 'COMM'
		#  +-------------------------+
		#  |   (Frame Header COMM)   |
		#  +-------------------------+
		#  | Text-Codierung (1 Byte) |
		#  +-------------------------+
		#  |    Sprache (3 Bytes)    |
		#  +-------------------------+
		#  |   Beschreibung + $00    |
		#  +-------------------------+
		#  |    Inhalt des Frames    |
		#  +-------------------------+
		#
		#  Text-Codierungen:
		#  $00	ISO-8859-1
		#  $01	16-Bit Unicode (UTF-16) mit BOM
		#  $02	16-Bit Unicode (UTF-16) ohne BOM
		#  $03	8-Bit Unicode (UTF-8)
		#
		##############################

		$this->_read_id3();

		if ($this->_id3v2_included) {
			$frame_content = $this->_id3v2_frame('COMM');
			$sep = strpos($frame_content, "\0", 4) + 1;

			return substr($frame_content, $sep, strlen($frame_content) - $sep);
		}
		elseif ($this->_id3v1_included) {
			if (substr($this->_id3v1, 125, 1) == "\0" &&
				substr($this->_id3v1, 126, 1) != "\0") {	# ID3v1.1
				return chop(substr($this->_id3v1, 97, 28));
			}
			else {											# ID3v1
				return chop(substr($this->_id3v1, 97, 30));
			}
		}
		else return '';
	}


	############################################################################
	# Inhalt eines ID3v2-Frames lesen
	# STRING _id3v2_frame(STRING frame_id)
	# frame_id		Eine ID3v2.3-FrameID (ID3v2.2-IDs werden bersetzt)
	function _id3v2_frame($frame_id) {
		$offset	= 0;
		$size = 0;
		$flags = '';
		$content = '';

		switch ($this->_id3v2_major) {
			case 2:
				# ID3v2.2 Frame ######################
				#
				#  +---------------------------------+
				#  |        FrameID (3 Bytes)        |
				#  +---------------------------------+
				#  | Lnge (3 Bytes, 24-Bit Integer) |
				#  +---------------------------------+
				#  |             Inhalt              |
				#  +---------------------------------+
				#
				######################################

				$frame_id = $GLOBALS[v3_v2][$frame_id];

				$offset = strpos($this->_id3v2, $frame_id);
				if ($offset === false) return '';

				$size = big_endian_to_int(substr($this->_id3v2, $offset + 3, 3));

				$frame_content = substr($this->_id3v2, $offset + 6, $size);

				break;
			case 3:
				# ID3v2.3 Frame ######################
				#
				#  +---------------------------------+
				#  |        FrameID (4 Bytes)        |
				#  +---------------------------------+
				#  | Lnge (4 Bytes, 32-Bit Integer) |
				#  +---------------------------------+
				#  |         Flags (2 Bytes)         |
				#  +---------------------------------+
				#  |             Inhalt              |
				#  +---------------------------------+
				#
				#  Flags:
				#  %abc00000 %ijk00000
				#  a - tag alter preservation
				#  b - file alter preservation
				#  c - read only
				#  i - compression (zlib)
				#  j - encryption
				#  k - grouping identity
				#
				######################################

				$offset = strpos($this->_id3v2, $frame_id);
				if ($offset === false) return '';

				$size = big_endian_to_int(substr($this->_id3v2, $offset + 4, 4));

				$second_flags = str_pad(decbin(ord(substr($this->_id3v2, $offset + 9, 1))) , 8, '0', STR_PAD_LEFT);

				if ($second_flags[1] == true) {		# Verschlsselung
					$method_id = ord(substr($this->_id3v2, $offset + 10, 1));
					$encrypted = substr($this->_id3v2, $offset + 11, $size - 1);

					$frame_content = $encrypted;

					break;
				}

				if ($second_flags[0] == true) {		# GZip-Kompression
					$length_uncompressed = big_endian_to_int(substr($this->_id3v2, $offset + 10, 4));
					$compressed = substr($this->_id3v2, $offset + 14, $size - 4);

					$frame_content = gzuncompress($compressed, $length_uncompressed);
					if ($frame_content == false) return false;

					break;
				}

				$frame_content = substr($this->_id3v2, $offset + 10, $size);

				break;
			case 4:
				# ID3v2.4 Frame ################################
				#
				#  +-------------------------------------------+
				#  |              FrameID (4 Bytes)            |
				#  +-------------------------------------------+
				#  | Lnge (4 Bytes, 28-Bit SynchSafe Integer) |
				#  +-------------------------------------------+
				#  |               Flags (2 Bytes)             |
				#  +-------------------------------------------+
				#  |                   Inhalt                  |
				#  +-------------------------------------------+
				#
				#  Flags:
				#  %0abc0000 %0h00kmnp
				#  a - tag alter preservation
				#  b - file alter preservation
				#  c - read only
				#  h - grouping identity
				#  k - compression (zlib deflate)
				#  m - encryption
				#  n - unsynchronisation
				#  p - data length indicator
				#
				################################################

				$offset = strpos($this->_id3v2, $frame_id);
				if ($offset === false) return '';

				$size = big_endian_to_int(substr($this->_id3v2, $offset + 4, 4), true);

				$frame_content = substr($this->_id3v2, $offset + 10, $size);

				break;
		}

		return $frame_content;
	}

	############################################################################
	# Version des ID3-Tags
	# STRING id3_version()
	function id3_version() {
		$this->_read_id3();

		if ($this->_id3v2_included) {
			return 'ID3v2.'.$this->_id3v2_major.'.'.$this->_id3v2_minor;
		}
		elseif ($this->_id3v1_included) {
			if (substr($this->_id3v1, 125, 1) == "\0" &&
				substr($this->_id3v1, 126, 1) != "\0") {
				return 'ID3v1.1';
			}
			else return 'ID3v1';
		}
		else {
			return false;
		}
	}

	function last_error() {
		return $this->_error;
	}


	############################################################################
	#							MPEG-Frame-Header							   #
	############################################################################


	############################################################################
	# Offset des ersten MPEG-Frames
	# INT frame_offset()
	function frame_offset() {
		$this->_read_id3();

		return $this->_frame_offset;
	}

}


################################################################################
# Big-Endian-Byte-Wort in Integerwert konvertieren
# INT big_endian_to_int(STRING byteword, BOOL synchsafe, BOOL signed)
# byteword		Das zu behandelnde Byte-Wort
# synchsafe		Gibt an, ob das jeweilige MSB vernachlssigt werden soll
# signed		Gibt an, ob der Integerwert ein Vorzeichen enthalten soll
function big_endian_to_int($byteword, $synchsafe = false, $signed = false) {
	$intvalue = 0;
	$bytewordlen = strlen($byteword);

	for ($i = 0; $i < $bytewordlen; $i++) {
		if ($synchsafe) {	# MSB (most significant bit) vernachlssigen, effektiv 7-Bit Bytes
			$intvalue = $intvalue | (ord($byteword[$i]) & 0x7F) << (($bytewordlen - 1 - $i) * 7);
		} else {
			$intvalue += ord($byteword[$i]) * pow(256, ($bytewordlen - 1 - $i));
		}
	}

	if ($signed && !$synchsafe) {	# Synchsafe Integer drfen kein Vorzeichen haben
		if ($bytewordlen == 4) {
			$signmaskbit = 0x80 << (8 * ($bytewordlen - 1));
			if ($intvalue & $signmaskbit) {
				$intvalue = 0 - ($intvalue & ($signmaskbit - 1));
			}
		}
	}
	return intval(floor($intvalue));
}

function getDir($mp3Dir) {
// Returns directory as array[file]=date in newest to oldest order
	$dirArray = array();
	$diskdir = "./$mp3Dir/";
	if (is_dir($diskdir)) {
		$dh = opendir($diskdir);
		while (($file = readdir($dh)) != false ) {
			if (filetype($diskdir . $file) == "file" && $file[0]  != ".") {
				if (strrchr(strtolower($file), ".") == ".mp3") {
					$ftime = filemtime($mp3Dir."/".$file);
					$dirArray[$file] = $ftime;
				}
			}
		}
		closedir($dh);
	}
	asort($dirArray);
	$dirArray = array_reverse($dirArray);
	return $dirArray;
}
// Functions and Classes
function stripJunk ($text) {
// Strip non-text characters
	for ($c=0; $c<strlen($text); $c++) {
		if (ord($text[$c]) >= 32 AND ord($text[$c]) <= 122 AND ord($text[$c]) != 38) {
			$outText.=$text[$c];} else { $outText.= " ";
			}
	}
	return $outText;
}


?>
